# README

## LOMT - Laboratory Optimizer for Mass Testing

Laboratory Optimizer for Mass Testing (LOMT) is open source software for the management of COVID-19 pool testing. It allows the testing of 2 to 30 times more people with the existing resources of a laboratory by reducing the quantity of assays, reagents and time spent on each test.

### Applicability

* Qualitative test of the presence of a single target component — i.e., SARS-CoV-2 RNA
* PCR and other techniques that allow mixing several specimens into an assay
* A large number of single-type tests (>100) with a prevalence below 20%

### Use cases

* Frequent screening of high-risk groups or those involved in human interaction activities — medical staff, teachers and students, public services, company employees
* Epidemiological surveillance of the population to monitor the general infectious state, early detection of infected people and localization of foci of infection

### Technology

In the pool-testing method, the analysis process of a laboratory remains the same as in standard individual testing. The difference concerns only the analyte; instead of analyzing an individual specimen, a mixture of several specimens — a pool — is analyzed.

The program is a tool for laboratory personnel. It designs the specimen mixing plan, tracks specimens and assays, and decodes the results of assays completed into the results of specimens.

LOMT supports several pool-testing algorithms and strategies, from plain grouping of samples into pools to more complex algorithms with binary search, combinatorial analysis and probability analysis, and it suggests the optimal strategies depending on the prevalence, optimization task and operational constraints.

The program offers a user-friendly visual guide for manual specimen pipetting and result reporting, and can be integrated with the laboratory information system and laboratory robotics. 

https://lomt.jetware.org
(c) 2020 Jetware SRL
