class ApplicationController < ActionController::Base

	include ActingUserDevise

	before_action do
		# make request be available for all objects
		Thread.current[:request] = request

		# XXX пока отключено определение локалей
		# set locale via subdomain
=begin
		locale ||= request.subdomains.first if request.subdomains.present?
		locale ||= params[:locale]
		if locale
			locale = locale.to_sym
			I18n.available_locales.include?(locale) or locale = ML.default
			@locale = I18n.locale = Thread.current[:locale] = locale
		end
=end
	end

	after_action do
		# Clean up thread local variables from before_action.
		# Must be the last executed hook.
		Thread.current[:request] = nil
		Thread.current[:locale] = nil
	end

	class Error < StandardError
		attr_reader :status
		def initialize message, status = nil
			@status = status || 500
			super(message)
		end
	end
	rescue_from Error, with: :error_response
	 
	protected

	def error message = '', status = nil
		raise Error.new message, status
	end

	def error_response ex
		render text: ex.to_s, layout: true, status: ex.status
	end

	# Управляем cookie_disable
	def cookie_disabled?
		!@cookie_disable.nil?
	end

	def cookie_disable
		@cookie_disable = true
	end

	def cookie_enable
		@cookie_disable = nil
	end

end
