class PublicController < WebController
	skip_before_action :verify_authenticity_token

	# Вызываем set_expires после обработки запроса,
	# чтобы реагировать на изменения в cookie_disabled,
	# которые могут быть сделаны во время обработки запроса.
	after_action :set_expires

	before_action do
		cookie_disable
	end

	protected

	# Кэшируем страницы, если запрещены куки.
	def set_expires
		expires_in(24.hours, public: true) if cookie_disabled?
	end

	# Если вызывается несколько раз expires_in, то
	# в результате остается самое меньшее время и самая
	# меньшая видимость.
	def expires_in period, options = {}
		# Устанавливаем минимальный период
		if @expires_in_period.nil?
			@expires_in_period = period
		elsif @expires_in_period > period
			@expires_in_period = period
		end

		# Устанавливаем минимальную видимость
		if @expires_in_public.nil? || @expires_in_public
			@expires_in_public = options[:public]
		end

		super @expires_in_period, options.merge(public: @expires_in_public)
	end

end
