class Auth::Page < HyperMuiComponent
	include Hyperstack::Router

	render do
		puts "#{self} render"
		Switch {
			Route '/diary/auth/change_email', component: Auth::Page::ChangeEmail.to_n
			Route '/diary/auth/change_password', component: Auth::Page::ChangePassword.to_n
		}
	end

	class ChangeEmail < HyperMuiComponent
		before_mount do
			@errs = {}
		end
		render do
			FORM do
				TextField name: 'email', label: 'Email', required: true, inputRef: catch_ref(:email),
					error: !@errs[:email].blank?, helperText: @errs[:email] || ''
				Button(type: 'submit', variant: :contained, color: :primary) { 'Register' }
			end.on(:submit) do |evt|
				evt.prevent_default
				form = @refs.transform_values {|ref| Native(ref).value }
				puts "form: #{form}"
				AuthService.change_email(form)
					.then{|res|
						puts "#{self} then: #{res}"
					}
					.fail{|err|
						puts "#{self} fail: #{err}"
						errs = nil
						if err.is_a?(Hyperstack::Operation::ValidationException)
							errs = err.errors.symbolic.transform_values(&:m)
						end

						mutate @errs = errs unless errs.nil?
					}
			end
		end
	end # class ChangeEmail


	class ChangePassword < HyperMuiComponent
		before_mount do
			@errs = {}
		end
		render do
			FORM do
				TextField type: 'password', name: 'password', label: 'Password', required: true, inputRef: catch_ref(:password),
					error: !@errs[:password].blank?, helperText: @errs[:password] || ''
				TextField type: 'password', name: 'repeat_password', label: 'Repeat password', required: true, inputRef: catch_ref(:repeat_password),
					error: !@errs[:repeat_password].blank?, helperText: @errs[:repeat_password] || ''
				Button(type: 'submit', variant: :contained, color: :primary) { 'Register' }
			end.on(:submit) do |evt|
				evt.prevent_default
				form = @refs.transform_values {|ref| Native(ref).value }
				puts "form: #{form}"
				AuthService.change_password(form)
					.then{|res|
						puts "#{self} then: #{res}"
					}
					.fail{|err|
						puts "#{self} fail: #{err}"
						errs = nil
						if err.is_a?(Hyperstack::Operation::ValidationException)
							errs = err.errors.symbolic.transform_values(&:m)
						end

						mutate @errs = errs unless errs.nil?
					}
			end
		end
	end # class ChangeEmail

end
