module Batch
	class View::Index < HyperMuiComponent
		class Wrapped < HyperMuiComponent
			include Hyperstack::Router::Helpers
			before_mount do
				@created = nil
			end

			render(DIV) do
				View.Create()
				.on(:submitted) {|transient| mutate @created = transient }
				
				P {}
				
				if @created && @created.ready?
					Paper {
						Box(p: '1rem') {
							if @created.error?
								Typography(color: :error, variant: :h6) { 'Error' }
								Typography(color: :error) { @created.error.to_s }
								P {}
								Button(variant: :contained) { 'Dismiss' }
								.on(:click) { mutate @created = nil }
							else
								if @created.value.is_a? Batch::Api::AspectWork
									View.Work(batch: @created)
									.on(:started) { |id| history.push("/lomt/batches/#{id}") }
									.on(:deleted) { |batch| mutate @created = nil }
								else
									puts "unexpected value: #{@created.value}"
								end
							end
						}
					}
				end

				View.ServerList()

			end # render
		end

		imports `ReactRouter.withRouter(#{Wrapped.to_n})`
	end
end


