module Batch
	class View::List < HyperMuiComponent
		include Hyperstack::Router::Helpers

		param :collection

		render(DIV) do
			puts "#{self} render"
			puts "collection.size: #{collection.size}, class: #{collection.class}"
			if collection.empty?
				SPAN { 'no data' }
			else
				TABLE {
					THEAD {
						TR {
							TH { 'Batch ID' }
							TH { 'State' }
							TH { 'Samples' }
							TH { 'Assays' }
							TH { 'Stages' }
							TH { 'Created' }
							TH { 'Changed' }
						}
					}

					TBODY {
						collection.each do |obj|
							TR(key: obj.object_id) {
								TD { Link("/lomt/batches/#{obj.id}") { obj.tid } }
								TD {
									case obj.state
									when :new
										'New'
									when :plan
										'Plan'
									when :assay
										'Assay'
									when :ready
										'Ready'
									when :finished
										'Finished'
									end
								}
								TD {
									case obj.state
									when :new, :finished
										obj.all_samples_count.to_s
									else
										"#{obj.all_samples_count} (#{obj.samples_waiting_count}+#{obj.all_samples_left_count})"
									end
								}
								TD {
									case obj.state
									when :new
										'0'
									when :finished
										obj.all_assays_count.to_s
									else
										"#{obj.all_assays_count} (#{obj.assays_waiting_count})"
									end
								}
								TD { obj.depth.to_s }
								TD { obj.created_at.strftime('%F %R') }
								TD { obj.updated_at.strftime('%F %R') }
							}
						end
					}
				}
			end
		end
	end
end

=begin
TODO нужно правильно выводить sign titles
В идеале - нужно делать перевод sign в scope Model/VitalSign/Sign
Но можно пока брать и из класса описания знаков - но нужно проверять, что список знаков уже есть.

=end
