module Batch
	class View::Traces < HyperMuiComponent
		include Hyperstack::Router::Helpers

		param :batch_id

		before_mount do
			@traces = Api.traces id: batch_id
		end

		render(DIV) do
			puts "#{self} render"
			puts "@traces: #{@traces}"
			next unless  @traces.ready?
			aspect = @traces.value

			puts "aspect: #{aspect}"

			H2 { Link("/lomt/batches/#{aspect.id}") { "Batch #{aspect.tid} stages" } }
			aspect.traces.each_with_index do |trace, index|
				H3 { "Stage #{index+1}, #{trace[:planner_names].join(', ')}" }
				TableList title: "Plan", headers: %w[Sample Assay], collection: trace[:plan].map{|op| op.values_at :sample, :assay}
				TableList title: "Assay results", headers: %w[Assay Result], collection: Batch::boolean_to_plusminus(trace[:assay_results].to_a)
				TableList title: "Sample results", headers: %w[Sample Result], collection: Batch::boolean_to_plusminus(trace[:sample_results].to_a)
			end

		end

	end
end
