class Blink < HyperComponent

	class Nested < HyperMuiComponent
		param :classes, nils: true
		param :direct, default: true
		render do
			DIV(className: direct ? classes['blink_direct'] : classes['blink_invert']) {
				children.each &:render
			}
		end
	end

	STYLE = <<_EOF_
{
    '@keyframes blink_direct': {
        from: {opacity: 1},
        to: {opacity: 0}
    },
		'blink_direct': {
			animationName: '$blink_direct',
			animationDuration: '1s',
			animationTimingFunction: 'steps(2, end)',
			animationIterationCount:'infinite',
		},
    '@keyframes blink_invert': {
        from: {opacity: 0},
        to: {opacity: 1}
    },
		'blink_invert': {
			animationName: '$blink_invert',
			animationDuration: '1s',
			animationTimingFunction: 'steps(2, start)',
			animationIterationCount:'infinite',
		}
}
_EOF_

	STYLE_SETUP = "Mui.makeStyles(theme => (#{STYLE}))"
	STYLE_HOOK = `eval(#{STYLE_SETUP})`

	imports `
function(props) {
	const { children, ...other } = props;
	other.classes = #{STYLE_HOOK.to_n}();
	return React.createElement(#{Nested.to_n}, other, children);
}
`
end

