class HyperMuiComponent < HyperComponent
	# Idea from https://github.com/hyperstack-org/hyperstack/issues/273

	def method_missing(method_name, *args, **options, &block)
		return super if method_name != method_name.classify

		if Native(`Mui`).hasOwnProperty(method_name) || method_name == 'Tabs'
			Mui.send(method_name, *args, **options, &block)
		elsif method_name.start_with? 'Icon'
			Mui.send('Icon', *args, **options) { method_name[4..-1].underscore }
		else
			super
		end
	end

	def respond_to_missing?(method_name, include_private = false)
		return true if method_name == method_name.classify &&
				(Native(`Mui`).hasOwnProperty(method_name) ||
				 method_name.start_with?('Icon'))
		super
	end

	before_mount do
		@refs = {}
	end

	# Creates a callback for storing document elements references
	# in the local references hash.
	def catch_ref name
		->(el) { @refs[name] = el }
	end

	def self.createMuiTheme str
		setup = "Mui.createMuiTheme(#{str})"
		`eval(#{setup})`
	end

	extend Lazy

end
