module MixingPlan

	class Base < HyperMuiComponent
		param :plan
		param :direct, default: :sample # :sample, :assay
		param :samples_plate, default: nil, nils: true
		param :assays_plate, default: nil, nils: true

		def self.title
			nil
		end

		before_mount do
			assay = plan.first.last
			@assay_prefix = begin
				puts "assay: #{assay}"
				assay =~ /^(.*?)\d+$/
				$1
			end
		end

		def sample_assays
			@sample_assays ||= begin
				sample_assays = {}
				plan.each do |op|
					sample, assay = op
					sample = [sample[0], sample[1..-1]]
					assay = @assay_prefix ? [@assay_prefix, assay.delete_prefix(@assay_prefix)] : [assay[0], assay[1..-1]]
					(sample_assays[sample] ||= []) << assay
				end
				sample_assays
			end
		end

		def samples
			@samples ||= sample_assays.keys
		end

		def samples_plate_actual
			@samples_plate_actual ||= samples_plate || "1x#{samples.count}"
		end

		def samples_plate_size
			@samples_plate_size ||= samples_plate_actual.split('x').map(&:to_i)
		end

		def samples_rows
			Batch::Plate::ROWS[0...samples_plate_size.first]
		end

		def samples_cols
			Batch::Plate::COLUMNS[0...samples_plate_size.last]
		end

		def assay_samples
			@assay_samples ||= begin
				assay_samples = {}
				plan.each do |op|
					sample, assay = op
					sample = [sample[0], sample[1..-1]]
					assay = @assay_prefix ? [@assay_prefix, assay.delete_prefix(@assay_prefix)] : [assay[0], assay[1..-1]]
					(assay_samples[assay] ||= []) << sample
				end
				assay_samples
			end
		end

		def assays
			@assays ||= assay_samples.keys
		end

		def assays_plate_actual
			@assays_plate_actual ||= assays_plate || "1x#{assays.count}"
		end

		def assays_plate_size
			@assays_plate_size ||= assays_plate_actual.split('x').map(&:to_i)
		end

		# Если для анализов не указан планшет, значит используется дефолтная
		# раскладка с префиксом
		def assays_rows
			if assays_plate
				Batch::Plate::ROWS[0...assays_plate_size.first]
			else
				[@assay_prefix] # single row
			end
		end

		def assays_cols
			Batch::Plate::COLUMNS[0...assays_plate_size.last]
		end

		def map
			case direct
			when :sample
				sample_assays
			when :assay
				assay_samples
			end
		end


	end # class Base

end

