class MixingPlan::CrossTables < MixingPlan::Base

	def self.title
		'Cross tables'
	end

	render do
		puts "#{self}:render"

		Grid(container: true, spacing: 3) {
			Grid(item: true, xs: 12, md: 6) do
				Typography(variant: :h6) { "Samples" }

				TableContainer(component: :Paper) {
					TableHead { TableRow {
						TableCell {}
						samples_cols.each {|col| TableCell(align: :center) { col } }
					} }
					TableBody {
						samples_rows.each {|row|
							TableRow {
								TableCell(component: :th, scope: :row) { row }
								samples_cols.each {|col| TableCell { sample_assays[[row, col]]&.map(&:join)&.join ' ' } }
							}
						}
					}
				}
			end

			Grid(item: true, xs: 12, md: 6) do
				Typography(variant: :h6) { "Assays" }

				TableContainer(component: :Paper) {
					TableHead { TableRow {
						TableCell {}
						assays_cols.each {|col| TableCell(align: :center) { col } }
					} }
					TableBody {
						assays_rows.each {|row|
							TableRow {
								TableCell(component: :th, scope: :row) { row }
								assays_cols.each {|col| TableCell { assay_samples[[row, col]]&.map(&:join)&.join ' ' } }
							}
						}
					}
				}
			end
		}

	end # render

end

