module MixingPlan::Directions
	class Single < Base

		def initialize map, direct
			super
			@count = @targets.map(&:size).reduce(&:+)
			@left_samples = @left_assays = Array::EMPTY
		end

		def select sample, assay
			return if sample.nil? && assay.nil?
			case @direct
			when :sample
				source, target = sample, assay
			when :assay
				source, target = assay, sample
			end

			cap = 0
			@targets.each_with_index do |targets, i|
				if @sources[i] == source && (target.nil? || targets.include?(target))
					@step = cap
					@step += targets.index(target) if target
					break
				else
					cap += targets.size
				end
			end

			update
		end

		def update
			cap = 0

			@targets.each_with_index do |targets, i|
				cap += targets.size
				next if cap <= @step
				curr_target = @step-cap+targets.size

				case @direct
				when :sample
					@curr_samples = [@sources[i]]

					@left_assays = targets[curr_target+1..-1]
					@curr_assays = [targets[curr_target]]

					@done_assays = targets[0...curr_target]
				when :assay
					@curr_assays = [@sources[i]]

					@left_samples = targets[curr_target+1..-1]
					@curr_samples = [targets[curr_target]]

					@done_samples = targets[0...curr_target]
				end

				break
			end

			mutate
		end

		def view
			line = nil
			if @step
				cap = 0
				line = 0
				@targets.each_with_index do |targets, i|
					cap += targets.size
					if cap > @step
						line = i
						break
					end
				end
			end
			self.class::View(map: @map, direct: @direct, line: line)
		end

	end
end


