class MixingPlan::Home < HyperMuiComponent
	fires :done
	param :plan, type: Array
	param :samples_plate, default: nil, nils: true
	param :assays_plate, default: nil, nils: true

	before_mount do
		@direct = nil
		@tab = 0
	end

#	VIEWERS = %w[OperationsList VisualGuide TabletGuide GroupOperations CrossTables]
	VIEWERS = %w[OperationsList VisualGuide GroupOperations CrossTables]
	VIEWER_WITH_DIRECT = %w[VisualGuide TabletGuide GroupOperations]

	render(DIV) do
		puts "#{self}.render"

		if @direct.nil?
			# Если для каждого сэмпла не больше одного анализа (например, direct или bisector),
			# то группируем по assay
			plan_samples = plan.map(&:first)
			@direct = plan_samples.uniq!.nil? ? :assay : :sample
		end

		Mui.Tabs(value: @tab, variant: :scrollable, scrollButtons: :on) {
			VIEWERS.each_with_index do |viewer, i|
				Tab label: MixingPlan::const_get(viewer).title
			end
		}
		.on(:change){ |evt, value|
			puts "tab change: #{evt}, value: #{value}"
			mutate @tab = value
		}

		VIEWERS.each_with_index do |viewer, i|
			if @tab == i
				if VIEWER_WITH_DIRECT.include? viewer
					Box(mb: '1rem') {
						FormControl(component: :fieldset) {
							FormLabel { 'Direct by:' }
							RadioGroup(value: @direct, row: true) {
								FormControlLabel value: :sample, control: Radio().as_node.to_n, label: "sample"
								FormControlLabel value: :assay, control: Radio().as_node.to_n, label: "assay"
							}
							.on(:change) {|evt|
								@direct = evt.target.value
								mutate
							}
						}
					}
				end

				MixingPlan.send(viewer, key: @direct, plan: plan, samples_plate: samples_plate, direct: @direct)
				.on(:done) { done! }
			end
		end

	end # render


end
