module MixingPlan::Plate

	class Base < HyperMuiComponent

		# Persistent param
		param :plate, default: nil, nils: true
		param :rows, default: nil, nils: true
		param :cols, default: nil, nils: true

		# Списки лунок передаются в виде пар строк: строка, столбец
		DEFAULT = {
			curr: Array::EMPTY,
			left: Array::EMPTY,
			done: Array::EMPTY
		}

		# volatile params
		DEFAULT.each do |key, value|
			param key, default: value
		end

		before_mount do
			if plate
				@size = plate.split('x').map(&:to_i)
			else
				@size = [rows.count, cols.count]
			end
			@rows = rows || Batch::Plate::ROWS[0...@size.first]
			@cols = cols || Batch::Plate::COLUMNS[0...@size.last]
		end

		class Matrix < HyperMuiComponent
			param :rows
			param :cols

			DEFAULT.each do |key, value|
				param key, default: value
			end

			def should_component_update? new_params, new_state
				begin
					if new_params[:curr] != @Curr
						@curr_rows = @curr_cols = nil
						true
					end
				end || super
			end

			def curr_rows
				@curr_rows ||= curr.map(&:first).uniq
			end

			def curr_cols
				@curr_cols ||= curr.map(&:last).uniq
			end

		end

	end # class Base

end
