class PopoverList < HyperMuiComponent
	param :title
	param :listComponent, default: :TableList
	param :collection
	param :headers, default: nil, nils: true

	# По умолчанию список выводится через TableList - в виде таблицы. Но можно и через другие виджеты списков, например, TextareaList, который выводит как текст, с полями, разделенными табуляцией.

	before_mount do
		@anchor = nil
	end

	render(SPAN) do
		Tooltip(title: title) {
			if collection && collection.size > 0
				SPAN(style: {'textDecoration' => 'underline', 'textDecorationStyle' => 'dotted'}) { "#{collection.size}" }
					.on(:click){|e| mutate @anchor = e.current_target }
			else
				SPAN { "#{collection&.size || '-'}" }
			end
		}
		if collection && collection.size > 0
			Popover(
					open: !@anchor.nil?,
					anchorEl: @anchor&.to_n,
					anchorOrigin: {vertical: :bottom, horizontal: :left}.to_n,
					transformOrigin: { vertical: :top, horizontal: :left}.to_n,
				) {
					Box(p: '1rem') { 
						send self.listComponent, title: title, collection: collection, headers: headers
					}
				}
			.on(:close){ mutate @anchor = nil }
		end
	end # render

end

