class TableList < HyperMuiComponent
	param :collection
	param :title
	param :headers, default: nil, nils: true

	before_mount do
		@anchor = nil
	end

	render(DIV) do
		Typography(variant: :h6) { "#{title}: #{collection.size}" }
		TABLE {
			if headers
				THEAD { TR {
					headers.each do |header|
						TH { header.to_s }
					end
				} }
			end
			if collection
				TBODY {
					collection.each do |row|
						TR {
							if row.is_a? Enumerable
								row.each do |col|
									TD { col.to_s }
								end
							else
								TD { row.to_s }
							end
						}
					end
				}
			end
		}
	end # render

end

