class TextareaList < HyperMuiComponent
	param :collection
	param :title
	param :headers, default: nil, nils: true

	before_mount do
		@anchor = nil
	end

	render(DIV) do
		Typography(variant: :h6, style: {flexGrow: 1}) { "#{title}: #{collection.size}" }

		content = collection.map{ |row|
			row.is_a?(Enumerable) ? row.map(&:to_s).join("\t") : row.to_s
		}
		content.unshift headers.map(&:to_s).join("\t") if headers

		DIV {
			TextareaAutosize(rowsMax: 6, readOnly: true, value: content.join("\n"))
		}
	end # render

end

