module Batch
	module Plate
		#  https://en.wikipedia.org/wiki/Microplate

		ARRANGEMENTS = %w[
			2x3
			3x4
			4x6
			6x8
			8x12
			3x32
			16x24
		]

		ROWS = ('A'..'Z').to_a
		COLUMNS = (1..100).map(&:to_s).to_a

		# Enumerate the wells of a plate
		# @param arr (String) - arrangment of the plate
		def list arr
			rows_count, columns_count = arr.split('x').map(&:to_i)
			rows = ROWS[0...rows_count]
			columns = COLUMNS[0...columns_count]
			rows.product(columns).map(&:join)
		end

		def size arr
			arr.split('x').map(&:to_i).reduce(:*)
		end

		module_function :list
		module_function :size

	end
end
