require 'lab'
module Lab
	class Model < ApplicationRecord
		self.table_name = 'labs'
		has_many :batches, class_name: 'Batch::Record', foreign_key: :lab_id
		has_and_belongs_to_many :users, class_name: 'User', foreign_key: :lab_id

		store :profile, accessors: PROFILE_FIELDS

		validates :phone, format: { with: /\A[0-9.,()_+-]+\z/, message: "no letters allowed" }, allow_blank: true

	end
end
