class ProfileRegistration

	FIELDS = {
			email: {
				title: 'Email',
				type: :string,
				required: true
			}
		}
		.merge(Lab::PROFILE_FIELDS.map_hash do |field|
			{title: Lab::TITLES[field], type: Lab::TYPES[field]}
		end)

	attr_reader :fields
	def initialize
		@fields = FIELDS
	end

	def process params
		@fields = @fields.deep_dup

		model = Lab::Model.new params.permit(*Lab::PROFILE_FIELDS)
		unless model.valid?
			model.errors.each do |field, error|
				@fields[field][:error] = error
			end
		end
		@fields.each do |field, attrs|
			attrs[:value] = params[field]
			if attrs[:required] && params[field].blank?
				attrs[:error] = 'Missing data'
			end
		end
	end

	def valid?
		@fields.values.none?{|attrs| attrs[:error]}
	end

	def form
			@fields.transform_values{|attrs| attrs[:value]}
	end

end
