class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable unless RUBY_ENGINE == 'opal'
	# TODO добавлять omniauthable
	# TODO добавлять confirmable,
	#   но не ограничивать по времени, а не давать основные функции пока не придет подтверждение
	#   или можно заводить несколько аккаунтов с одним email и не давать им доступа друг к другу,
	#   а после валидации объединять все в валидированный email
	has_many :vital_signs, class_name: 'VitalSign::Model', foreign_key: :created_by_id
	has_many :batches, class_name: 'Batch::Record', foreign_key: :user_id
	has_and_belongs_to_many :labs, class_name: 'Lab::Model', association_foreign_key: :lab_id

	class << self
		include Hyperstack::State::Observable
		def current_user= user
			Hyperstack::ClientDrivers.opts[:acting_user_id] = user.is_a?(User) ? user.id : user
			mutate @current_user = user ? (user.is_a?(User) ? user : User.find_by_id(user)) : nil
		end

		def current_user
			observe @current_user
		end
	end

end
