  # app/policies/application_policy.rb

  # Policies regulate access to your public models
  # The following policy will open up full access (but only in development)
  # The policy system is very flexible and powerful.  See the documentation
  # for complete details.
  class Hyperstack::ApplicationPolicy
    # Allow any session to connect:
    always_allow_connection
    # Send all attributes from all public models
    regulate_all_broadcasts { |policy| policy.send_all }
    # Allow all changes to models
    allow_change(to: :all, on: [:create, :update, :destroy]) { true }
    # allow remote access to all scopes - i.e. you can count or get a list of ids
    # for any scope or relationship
    ApplicationRecord.regulate_scope :all
  end unless Rails.env.production?
