require 'lto/batch/stage'
module LTO
	class Batch
		class Trace < Stage

=begin

В Trace хранятся входные и выходные данные этапа

=end
			include InstanceVariablesEqual

			def initialize front
				@plan, @planner_names, @assay_results, @sample_results =
					front.plan, front.planner_names, front.assay_results, front.sample_results
			end
			attr_reader :plan, :planner_names, :assay_results

			def samples
				@sample_results.keys
			end

			def assays
				@assay_results.keys
			end

			def sample_results
				@sample_results.reject{|k,v| v.nil?}
			end

			# Сэмплы, для которых тестирование продолжается на следующем этапе
			def samples_left
				@sample_results.select{|k,v| v.nil?}.keys
			end

			def dump_init
				{
					plan:            @plan.map{|op| {sample: op.sample, assay: op.assay} },
					planner_names:   @planner_names,
					assay_results:    @assay_results,
					sample_results:  @sample_results,
				}
			end

			def self.load_init hash
				hash.transform_keys!(&:to_sym)
				plan = hash[:plan].map{|op|
					op.transform_keys!(&:to_sym)
					LTO::Planner::Operation.new op[:sample], op[:assay]
				}

				obj = allocate
				%i[planner_names assay_results sample_results].each do |key, value|
					obj.instance_variable_set "@#{key}", hash[key]
				end
				obj.instance_variable_set :@plan, plan
				obj
			end

		end # class Trace
	end # class Batch
end # module LTO


=begin

Для samples_forwarded можно показывать также группы, в которых находятся сэмплы, и информацию о min_positives для них.


=end
