require 'lto/planner'
module LTO
	module Planner

		# Прямой планировщик, для каждого сэмпла один тест
		class Direct < Base
			def initialize strategy, samples, **kwargs
				super strategy, samples, **kwargs
				build_plan
			end

			def build_plan
				@assays = (1..@samples.size).to_a.map{|s| "T#{batch.join('-')}/#{s}"}
				@assay_samples = (0...@samples.size).map{|i| [i]}
			end

			def infer
				results = (0...@samples.size).map{|i| @assay_output[i]}
			end

			def next_planners
				return [] unless @assay_output.any?(&:nil?)
				# Если какие-то тесты оказались неудачными, передаем их повторно в этот же планировщик
				left_samples = @assay_output.each_with_index.map{|result, i| result.nil? ? @samples[i] : nil}.compact
				strategy_planners left_samples, batch: @batch + [0]
			end

		end # class Direct
	end # module Planner
end # module LTO

=begin

build_plan

Не нужно балансировать группы по размеру, если сэмплы не делятся на группы с
полными пулами: для сбалансированных групп в худшем случае (multiple positives)
число тестов будет одинаковым, а в лучшем случае (single positive) число тестов
окажется больше, чем если группы будут включать маленькую группу с остатком.

=end
